Overview | Package | Class | Use | Tree | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.xml.sax.ext
Class DefaultHandler2

    java.lang.Object
      |
      +--org.xml.sax.helpers.DefaultHandler
            |
            +--org.xml.sax.ext.DefaultHandler2

All Implemented Interfaces:
  ContentHandler, DeclHandler, DTDHandler, EntityResolver, EntityResolver2, ErrorHandler, LexicalHandler

public class DefaultHandler2
extends DefaultHandler
implements LexicalHandler, DeclHandler, EntityResolver2

This class extends the SAX2 base handler class to support the SAX2 `LexicalHandler` and `DeclHandler` extensions. The added handler methods just return; subclassers may override on a method-by-method basis.

> This module, both source code and documentation, is in the Public Domain, and comes with NO WARRANTY.

Note: this class might yet learn that the ContentHandler.setDocumentLocator() call might be passed a `Locator2` object, and that the ContentHandler.startElement() call might be passed a `Attributes2` object.

Since:
  SAX 2.0 (extensions 1.1 alpha)
Version:
  TBS
Author:
  David Brownell

Constructor Summary
`DefaultHandler2()` Constructs a handler which ignores all parsing events.

Method Summary
`void` | `attributeDecl(java.lang.String eName, java.lang.String aName, java.lang.String type, java.lang.String mode, java.lang.String value)` Report an attribute type declaration.
`void` | `comment(char[] ch, int start, int length)` Report an XML comment anywhere in the document.
`void` | `elementDecl(java.lang.String name, java.lang.String model)` Report an element type declaration.
`void` | `endCDATA()` Report the end of a CDATA section.
`void` | `endDTD()` Report the end of DTD declarations.
`void` | `endEntity(java.lang.String name)` Report the end of an entity.
`void` | `externalEntityDecl(java.lang.String name, java.lang.String publicId, java.lang.String systemId)` Report a parsed external entity declaration.
`InputSource` | `getExternalSubset(java.lang.String name, java.lang.String baseURI)` Tells the parser that if no external subset has been declared in the document text, none should be used.
`void` | `internalEntityDecl(java.lang.String name, java.lang.String value)` Report an internal entity declaration.
`InputSource` | `resolveEntity(java.lang.String name, java.lang.String publicId, java.lang.String baseURI, java.lang.String systemId)` Tells the parser to resolve the systemId against the baseURI and read the entity text from that resulting absolute URI.
`void` | `startCDATA()` Report the start of a CDATA section.
`void` | `startDTD(java.lang.String name, java.lang.String publicId, java.lang.String systemId)` Report the start of DTD declarations, if any.
`void` | `startEntity(java.lang.String name)` Report the beginning of some internal and external XML entities.

Methods inherited from class org.xml.sax.helpers.DefaultHandler
`characters, endDocument, endElement, endPrefixMapping, error, fatalError, ignorableWhitespace, notationDecl, processingInstruction, resolveEntity, setDocumentLocator, skippedEntity, startDocument, startElement, startPrefixMapping, unparsedEntityDecl, warning`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.xml.sax.EntityResolver
`resolveEntity`

Constructor Detail

### DefaultHandler2

    public DefaultHandler2()

  Constructs a handler which ignores all parsing events.

Method Detail

### startCDATA

    public void startCDATA()
                    throws SAXException

  Description copied from interface: `LexicalHandler`
  Report the start of a CDATA section.

  The contents of the CDATA section will be reported through the regular `characters` event; this event is intended only to report the boundary.

  Specified by:
    `startCDATA` in interface `LexicalHandler`
  Following copied from interface: `org.xml.sax.ext.LexicalHandler`
  Throws:
    `SAXException` - The application may raise an exception.
  See Also:
    `LexicalHandler.endCDATA()`

### endCDATA

    public void endCDATA()
                  throws SAXException

  Description copied from interface: `LexicalHandler`
  Report the end of a CDATA section.
  Specified by:
    `endCDATA` in interface `LexicalHandler`
  Following copied from interface: `org.xml.sax.ext.LexicalHandler`
  Throws:
    `SAXException` - The application may raise an exception.
  See Also:
    `LexicalHandler.startCDATA()`

### startDTD

    public void startDTD(java.lang.String name,
                         java.lang.String publicId,
                         java.lang.String systemId)
                  throws SAXException

  Description copied from interface: `LexicalHandler`
  Report the start of DTD declarations, if any.

  This method is intended to report the beginning of the DOCTYPE declaration; if the document has no DOCTYPE declaration, this method will not be invoked.

  All declarations reported through `DTDHandler` or `DeclHandler` events must appear between the startDTD and `endDTD` events. Declarations are assumed to belong to the internal DTD subset unless they appear between `startEntity` and `endEntity` events. Comments and processing instructions from the DTD should also be reported between the startDTD and endDTD events, in their original order of (logical) occurrence; they are not required to appear in their correct locations relative to DTDHandler or DeclHandler events, however.

  Note that the start/endDTD events will appear within the start/endDocument events from ContentHandler and before the first `startElement` event.

  Specified by:
    `startDTD` in interface `LexicalHandler`
  Following copied from interface: `org.xml.sax.ext.LexicalHandler`
  Parameters:
    `name` - The document type name.
    `publicId` - The declared public identifier for the external DTD subset, or null if none was declared.
    `systemId` - The declared system identifier for the external DTD subset, or null if none was declared. (Note that this is not resolved against the document base URI.)
  Throws:
    `SAXException` - The application may raise an exception.
  See Also:
    `LexicalHandler.endDTD()`, `LexicalHandler.startEntity(java.lang.String)`

### endDTD

    public void endDTD()
                throws SAXException

  Description copied from interface: `LexicalHandler`
  Report the end of DTD declarations.

  This method is intended to report the end of the DOCTYPE declaration; if the document has no DOCTYPE declaration, this method will not be invoked.

  Specified by:
    `endDTD` in interface `LexicalHandler`
  Following copied from interface: `org.xml.sax.ext.LexicalHandler`
  Throws:
    `SAXException` - The application may raise an exception.
  See Also:
    `LexicalHandler.startDTD(java.lang.String, java.lang.String, java.lang.String)`

### startEntity

    public void startEntity(java.lang.String name)
                     throws SAXException

  Description copied from interface: `LexicalHandler`
  Report the beginning of some internal and external XML entities.

  The reporting of parameter entities (including the external DTD subset) is optional, and SAX2 drivers that report LexicalHandler events may not implement it; you can use the `http://xml.org/sax/features/lexical-handler/parameter-entities` feature to query or control the reporting of parameter entities.

  General entities are reported with their regular names, parameter entities have '%' prepended to their names, and the external DTD subset has the pseudo-entity name "[dtd]".

  When a SAX2 driver is providing these events, all other events must be properly nested within start/end entity events. There is no additional requirement that events from `DeclHandler` or `DTDHandler` be properly ordered.

  Note that skipped entities will be reported through the `skippedEntity` event, which is part of the ContentHandler interface.

  Because of the streaming event model that SAX uses, some entity boundaries cannot be reported under any circumstances:

  - general entities within attribute values
  - parameter entities within declarations

  These will be silently expanded, with no indication of where the original entity boundaries were.

  Note also that the boundaries of character references (which are not really entities anyway) are not reported.

  All start/endEntity events must be properly nested.

  Specified by:
    `startEntity` in interface `LexicalHandler`
  Following copied from interface: `org.xml.sax.ext.LexicalHandler`
  Parameters:
    `name` - The name of the entity. If it is a parameter entity, the name will begin with '%', and if it is the external DTD subset, it will be "[dtd]".
  Throws:
    `SAXException` - The application may raise an exception.
  See Also:
    `LexicalHandler.endEntity(java.lang.String)`, `DeclHandler.internalEntityDecl(java.lang.String, java.lang.String)`, `DeclHandler.externalEntityDecl(java.lang.String, java.lang.String, java.lang.String)`

### endEntity

    public void endEntity(java.lang.String name)
                   throws SAXException

  Description copied from interface: `LexicalHandler`
  Report the end of an entity.
  Specified by:
    `endEntity` in interface `LexicalHandler`
  Following copied from interface: `org.xml.sax.ext.LexicalHandler`
  Parameters:
    `name` - The name of the entity that is ending.
  Throws:
    `SAXException` - The application may raise an exception.
  See Also:
    `LexicalHandler.startEntity(java.lang.String)`

### comment

    public void comment(char[] ch,
                        int start,
                        int length)
                 throws SAXException

  Description copied from interface: `LexicalHandler`
  Report an XML comment anywhere in the document.

  This callback will be used for comments inside or outside the document element, including comments in the external DTD subset (if read). Comments in the DTD must be properly nested inside start/endDTD and start/endEntity events (if used).

  Specified by:
    `comment` in interface `LexicalHandler`
  Following copied from interface: `org.xml.sax.ext.LexicalHandler`
  Parameters:
    `ch` - An array holding the characters in the comment.
    `start` - The starting position in the array.
    `length` - The number of characters to use from the array.
  Throws:
    `SAXException` - The application may raise an exception.

### attributeDecl

    public void attributeDecl(java.lang.String eName,
                              java.lang.String aName,
                              java.lang.String type,
                              java.lang.String mode,
                              java.lang.String value)
                       throws SAXException

  Description copied from interface: `DeclHandler`
  Report an attribute type declaration.

  Only the effective (first) declaration for an attribute will be reported. The type will be one of the strings "CDATA", "ID", "IDREF", "IDREFS", "NMTOKEN", "NMTOKENS", "ENTITY", "ENTITIES", a parenthesized token group with the separator "|" and all whitespace removed, or the word "NOTATION" followed by a space followed by a parenthesized token group with all whitespace removed.

  The value will be the value as reported to applications, appropriately normalized and with entity and character references expanded.

  Specified by:
    `attributeDecl` in interface `DeclHandler`
  Following copied from interface: `org.xml.sax.ext.DeclHandler`
  Parameters:
    `eName` - The name of the associated element.
    `aName` - The name of the attribute.
    `type` - A string representing the attribute type.
    `mode` - A string representing the attribute defaulting mode ("#IMPLIED", "#REQUIRED", or "#FIXED") or null if none of these applies.
    `value` - A string representing the attribute's default value, or null if there is none.
  Throws:
    `SAXException` - The application may raise an exception.

### elementDecl

    public void elementDecl(java.lang.String name,
                            java.lang.String model)
                     throws SAXException

  Description copied from interface: `DeclHandler`
  Report an element type declaration.

  The content model will consist of the string "EMPTY", the string "ANY", or a parenthesised group, optionally followed by an occurrence indicator. The model will be normalized so that all parameter entities are fully resolved and all whitespace is removed,and will include the enclosing parentheses. Other normalization (such as removing redundant parentheses or simplifying occurrence indicators) is at the discretion of the parser.

  Specified by:
    `elementDecl` in interface `DeclHandler`
  Following copied from interface: `org.xml.sax.ext.DeclHandler`
  Parameters:
    `name` - The element type name.
    `model` - The content model as a normalized string.
  Throws:
    `SAXException` - The application may raise an exception.

### externalEntityDecl

    public void externalEntityDecl(java.lang.String name,
                                   java.lang.String publicId,
                                   java.lang.String systemId)
                            throws SAXException

  Description copied from interface: `DeclHandler`
  Report a parsed external entity declaration.

  Only the effective (first) declaration for each entity will be reported.

  Specified by:
    `externalEntityDecl` in interface `DeclHandler`
  Following copied from interface: `org.xml.sax.ext.DeclHandler`
  Parameters:
    `name` - The name of the entity. If it is a parameter entity, the name will begin with '%'.
    `publicId` - The declared public identifier of the entity, or null if none was declared.
    `systemId` - The declared system identifier of the entity.
  Throws:
    `SAXException` - The application may raise an exception.
  See Also:
    `DeclHandler.internalEntityDecl(java.lang.String, java.lang.String)`, `DTDHandler.unparsedEntityDecl(java.lang.String, java.lang.String, java.lang.String, java.lang.String)`

### internalEntityDecl

    public void internalEntityDecl(java.lang.String name,
                                   java.lang.String value)
                            throws SAXException

  Description copied from interface: `DeclHandler`
  Report an internal entity declaration.

  Only the effective (first) declaration for each entity will be reported. All parameter entities in the value will be expanded, but general entities will not.

  Specified by:
    `internalEntityDecl` in interface `DeclHandler`
  Following copied from interface: `org.xml.sax.ext.DeclHandler`
  Parameters:
    `name` - The name of the entity. If it is a parameter entity, the name will begin with '%'.
    `value` - The replacement text of the entity.
  Throws:
    `SAXException` - The application may raise an exception.
  See Also:
    `DeclHandler.externalEntityDecl(java.lang.String, java.lang.String, java.lang.String)`, `DTDHandler.unparsedEntityDecl(java.lang.String, java.lang.String, java.lang.String, java.lang.String)`

### getExternalSubset

    public InputSource getExternalSubset(java.lang.String name,
                                         java.lang.String baseURI)
                                  throws SAXException,
                                         java.io.IOException

  Tells the parser that if no external subset has been declared in the document text, none should be used.
  Specified by:
    `getExternalSubset` in interface `EntityResolver2`
  Following copied from interface: `org.xml.sax.ext.EntityResolver2`
  Parameters:
    `name` - Identifies the document root element. This name comes from a DOCTYPE declaration (where available) or from the actual root element.
    `baseURI` - The document's base URI, serving as an additional hint for selecting the external subset. This is always an absolute URI, unless it is null because the XMLReader was given an InputSource without one.
  Returns:
    An InputSource object describing the new external subset to be used by the parser, or null to indicate that no external subset is provided.
  Throws:
    `SAXException` - Any SAX exception, possibly wrapping another exception.
    `java.io.IOException` - Probably indicating a failure to create a new InputStream or Reader, or an illegal URL.

### resolveEntity

    public InputSource resolveEntity(java.lang.String name,
                                     java.lang.String publicId,
                                     java.lang.String baseURI,
                                     java.lang.String systemId)
                              throws SAXException,
                                     java.io.IOException

  Tells the parser to resolve the systemId against the baseURI and read the entity text from that resulting absolute URI. Note that you should also override both this method and `DefaultHandler.resolveEntity()`, rather than only one of them, so that no matter what kind of SAX2 parser you use, it will have an appropriate entity resolution policy.
  Specified by:
    `resolveEntity` in interface `EntityResolver2`
  Following copied from interface: `org.xml.sax.ext.EntityResolver2`
  Parameters:
    `name` - Identifies the external entity being resolved. Either "[dtd]" for the external subset, or a name starting with "%" to indicate a parameter entity, or else the name of a general entity.
    `publicId` - The public identifier of the external entity being referenced (normalized as required by the XML specification, or null if none was supplied.
    `baseURI` - The URI with respect to which relative systemIDs are interpreted. This is always an absolute URI, unless it is null because the XMLReader was given an InputSource without one. This URI is defined by the XML specification to be the one associated with the "<" starting the relevant declaration.
    `systemId` - The system identifier of the external entity being referenced; either a relative or absolute URI.
  Returns:
    An InputSource object describing the new input source to be used by the parser. Returning null directs the parser to resolve the system ID against the base URI and open a connection to resulting URI.
  Throws:
    `SAXException` - Any SAX exception, possibly wrapping another exception.
    `java.io.IOException` - Probably indicating a failure to create a new InputStream or Reader, or an illegal URL.

Overview | Package | Class | Use | Tree | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Source code is under GPL (with library exception) in the JAXP project at http://www.gnu.org/software/classpathx/jaxp
This documentation was derived from that source code on 2001-11-20.